//
//  Demo_1Tests.m
//  Demo 1Tests
//
//  Created by Max Seelemann on 14.09.2018.
//  Copyright © 2018 Ulysses. All rights reserved.
//

#import <XCTest/XCTest.h>

@interface Demo_1Tests : XCTestCase
@end

@implementation Demo_1Tests

- (void)testMyCutCopy
{
	UITextView *textView = [UITextView new];
	textView.text = @"hello world";
	textView.selectedRange = NSMakeRange(1, 4);
	
	// Clear pasteboard
	UIPasteboard *pboard = UIPasteboard.generalPasteboard;
	pboard.string = @"";
	XCTAssertEqualObjects(pboard.string, @"");
	
	// Copy selected text
	[textView copy: nil];
	XCTAssertEqualObjects(pboard.string, @"ello");
	
	
	// Clear pasteboard and cut text
	pboard.string = @"";
	XCTAssertEqualObjects(pboard.string, @"");
	
	[textView cut: nil];
	XCTAssertEqualObjects(pboard.string, @"ello");
	
	// Check no actions on empty selection
	textView.selectedRange = NSMakeRange(1, 0);
	XCTAssertFalse([textView canPerformAction:@selector(copy:) withSender:nil]);
	XCTAssertFalse([textView canPerformAction:@selector(cut:) withSender:nil]);
	
	// Check actions available on empty selection
	textView.selectedRange = NSMakeRange(1, 4);
	XCTAssertTrue([textView canPerformAction:@selector(copy:) withSender:nil]);
	XCTAssertTrue([textView canPerformAction:@selector(cut:) withSender:nil]);
}

@end
